diff --git a/src/main/java/net/minecraft/core/net/command/arguments/IntegerCoordinatesArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/IntegerCoordinatesArgumentType.java
new file mode 100644
index 000000000..4ac4ce3ec
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/IntegerCoordinatesArgumentType.java
@@ -0,0 +1,112 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.IntegerCoordinate;
+import net.minecraft.core.net.command.helpers.IntegerCoordinates;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.List;
+import java.util.concurrent.CompletableFuture;
+
+public class IntegerCoordinatesArgumentType implements ArgumentType<IntegerCoordinates> {
+    private static final List<String> EXAMPLES = Arrays.asList("~ ~ ~", "0 0 0", "~ ~60 ~", "~-20 ~10 -25");
+
+    public static IntegerCoordinatesArgumentType intCoordinates() {
+        return new IntegerCoordinatesArgumentType();
+    }
+
+    @Override
+    public IntegerCoordinates parse(StringReader reader) throws CommandSyntaxException {
+        int i = reader.getCursor();
+        IntegerCoordinate x = IntegerCoordinate.parse(reader);
+        if (!reader.canRead() || reader.peek() != ' ') {
+            if (reader.peek() == 'f' || reader.peek() == 'd') {
+                reader.skip();
+                if (!reader.canRead() || reader.peek() != ' ') {
+                    reader.setCursor(i);
+                    throw CommandExceptions.incomplete().createWithContext(reader);
+                }
+            } else {
+                reader.setCursor(i);
+                throw CommandExceptions.incomplete().createWithContext(reader);
+            }
+        }
+        reader.skip();
+        IntegerCoordinate y = IntegerCoordinate.parse(reader);
+        if (!reader.canRead() || reader.peek() != ' ') {
+            if (reader.peek() == 'f' || reader.peek() == 'd') {
+                reader.skip();
+                if (!reader.canRead() || reader.peek() != ' ') {
+                    reader.setCursor(i);
+                    throw CommandExceptions.incomplete().createWithContext(reader);
+                }
+            } else {
+                reader.setCursor(i);
+                throw CommandExceptions.incomplete().createWithContext(reader);
+            }
+        }
+        reader.skip();
+        IntegerCoordinate z = IntegerCoordinate.parse(reader);
+        return new IntegerCoordinates(x, y, z);
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        String string = builder.getRemaining();
+        Vec3 coordinates = ((CommandSource)context.getSource()).getBlockCoordinates();
+
+        if (coordinates == null) return builder.buildFuture();
+
+        int[] roundedCoordinates = new int[]{
+                MathHelper.floor(coordinates.x),
+                MathHelper.floor(coordinates.y),
+                MathHelper.floor(coordinates.z)
+        };
+
+        if (string.isEmpty()) {
+            String allCoordinates = roundedCoordinates[0] + " " + roundedCoordinates[1] + " " + roundedCoordinates[2];
+            try {
+                this.parse(new StringReader(allCoordinates));
+                builder.suggest(String.valueOf(roundedCoordinates[0]));
+                builder.suggest(roundedCoordinates[0] + " " + roundedCoordinates[1]);
+                builder.suggest(allCoordinates);
+            } catch (CommandSyntaxException ignored) {}
+        } else {
+            String[] strings = string.split(" ");
+            String allCoordinates;
+            switch (strings.length) {
+                case 1:
+                    allCoordinates = strings[0] + " " + roundedCoordinates[1] + " " + roundedCoordinates[2];
+                    try {
+                        this.parse(new StringReader(allCoordinates));
+                        builder.suggest(strings[0] + " " + roundedCoordinates[1]);
+                        builder.suggest(allCoordinates);
+                    } catch (CommandSyntaxException ignored) {}
+                    break;
+                case 2:
+                    allCoordinates = strings[0] + " " + strings[1] + " " + roundedCoordinates[2];
+                    try {
+                        this.parse(new StringReader(allCoordinates));
+                        builder.suggest(allCoordinates);
+                    } catch (CommandSyntaxException ignored) {}
+                    break;
+            }
+        }
+        return builder.buildFuture();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/ItemStackArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/ItemStackArgumentType.java
new file mode 100644
index 000000000..ac08acbd0
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/ItemStackArgumentType.java
@@ -0,0 +1,55 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.command.helpers.ItemStackArgumentParser;
+import net.minecraft.core.net.command.util.CommandHelper;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.List;
+import java.util.Locale;
+import java.util.concurrent.CompletableFuture;
+
+public class ItemStackArgumentType implements ArgumentType<ItemStack> {
+    private static final List<String> EXAMPLES = Arrays.asList("tool.sword.iron", "tool.sword.iron{name:\"Sword\", overrideName: true}", "tile.log");
+
+    public static ArgumentType<ItemStack> itemStack() {
+        return new ItemStackArgumentType();
+    }
+
+    @Override
+    public ItemStack parse(StringReader reader) throws CommandSyntaxException {
+        ItemStackArgumentParser parser = new ItemStackArgumentParser(reader);
+        return parser.parse();
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        StringReader stringReader = new StringReader(builder.getInput());
+        stringReader.setCursor(builder.getStart());
+        ItemStackArgumentParser parser = new ItemStackArgumentParser(stringReader);
+        try {
+            parser.parse();
+        } catch (CommandSyntaxException ignored) {}
+        return parser.fillSuggestions(builder, suggestionsBuilder -> {
+            String remaining = suggestionsBuilder.getRemaining().toLowerCase(Locale.ROOT);
+            for (Item item : Item.itemsList) {
+                if (item == null) continue;
+                CommandHelper.getStringToSuggest(item.getKey(), remaining).ifPresent(suggestionsBuilder::suggest);
+            }
+            suggestionsBuilder.buildFuture();
+        });
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/TimeArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/TimeArgumentType.java
new file mode 100644
index 000000000..b75757b98
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/TimeArgumentType.java
@@ -0,0 +1,76 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.exceptions.Dynamic2CommandExceptionType;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.concurrent.CompletableFuture;
+
+public class TimeArgumentType implements ArgumentType<Integer> {
+    private static final Collection<String> EXAMPLES = Arrays.asList("0d", "0s", "0t", "0");
+    private static final SimpleCommandExceptionType ERROR_INVALID_UNIT = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.time.invalid_unit"));
+    private static final Dynamic2CommandExceptionType ERROR_TICK_COUNT_TOO_LOW = new Dynamic2CommandExceptionType((object, object2) -> () -> I18n.getInstance().translateKeyAndFormat("command.argument_types.time.tick_count_too_low", object2, object));
+    private static final Map<String, Integer> UNITS = new HashMap<>();
+    final int minimum;
+
+    private TimeArgumentType(int i) {
+        this.minimum = i;
+    }
+
+    public static TimeArgumentType time() {
+        return new TimeArgumentType(0);
+    }
+
+    public static TimeArgumentType time(int i) {
+        return new TimeArgumentType(i);
+    }
+
+    @Override
+    public Integer parse(StringReader stringReader) throws CommandSyntaxException {
+        float f = stringReader.readFloat();
+        String string = stringReader.readUnquotedString();
+        int i = UNITS.getOrDefault(string, 0);
+        if (i == 0) {
+            throw ERROR_INVALID_UNIT.create();
+        }
+        int j = Math.round(f * (float)i);
+        if (j < this.minimum) {
+            throw ERROR_TICK_COUNT_TOO_LOW.create(j, this.minimum);
+        }
+        return j;
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> commandContext, SuggestionsBuilder suggestionsBuilder) {
+        StringReader stringReader = new StringReader(suggestionsBuilder.getRemaining());
+        try {
+            stringReader.readFloat();
+        } catch (CommandSyntaxException commandSyntaxException) {
+            return suggestionsBuilder.buildFuture();
+        }
+        return CommandHelper.suggest(UNITS.keySet(), suggestionsBuilder.createOffset(suggestionsBuilder.getStart() + stringReader.getCursor()));
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+
+    static {
+        UNITS.put("d", 24000);
+        UNITS.put("s", 20);
+        UNITS.put("t", 1);
+        UNITS.put("", 1);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/Vec3ArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/Vec3ArgumentType.java
new file mode 100644
index 000000000..a23b840b4
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/Vec3ArgumentType.java
@@ -0,0 +1,108 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.DoubleCoordinate;
+import net.minecraft.core.net.command.helpers.DoubleCoordinates;
+import net.minecraft.core.util.phys.Vec3;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.List;
+import java.util.concurrent.CompletableFuture;
+
+public class Vec3ArgumentType implements ArgumentType<DoubleCoordinates> {
+    private static final List<String> EXAMPLES = Arrays.asList("~ ~ ~", "0 0 0", "~ ~60 ~", "~-20 ~10 ~-25.5");
+
+    public static Vec3ArgumentType vec3d() {
+        return new Vec3ArgumentType();
+    }
+
+    @Override
+    public DoubleCoordinates parse(StringReader reader) throws CommandSyntaxException {
+        int i = reader.getCursor();
+        DoubleCoordinate x = DoubleCoordinate.parse(reader);
+        if (!reader.canRead() || reader.peek() != ' ') {
+            if (reader.peek() == 'f' || reader.peek() == 'd') {
+                reader.skip();
+                if (!reader.canRead() || reader.peek() != ' ') {
+                    reader.setCursor(i);
+                    throw CommandExceptions.incomplete().createWithContext(reader);
+                }
+            } else {
+                reader.setCursor(i);
+                throw CommandExceptions.incomplete().createWithContext(reader);
+            }
+        }
+        reader.skip();
+        DoubleCoordinate y = DoubleCoordinate.parse(reader);
+        if (!reader.canRead() || reader.peek() != ' ') {
+            if (reader.peek() == 'f' || reader.peek() == 'd') {
+                reader.skip();
+                if (!reader.canRead() || reader.peek() != ' ') {
+                    reader.setCursor(i);
+                    throw CommandExceptions.incomplete().createWithContext(reader);
+                }
+            } else {
+                reader.setCursor(i);
+                throw CommandExceptions.incomplete().createWithContext(reader);
+            }
+        }
+        reader.skip();
+        DoubleCoordinate z = DoubleCoordinate.parse(reader);
+        return new DoubleCoordinates(x, y, z);
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        String string = builder.getRemaining();
+        Vec3 coordinates = ((CommandSource) context.getSource()).getCoordinates(true);
+
+        if (coordinates == null) return builder.buildFuture();
+
+        if (string.isEmpty()) {
+            String allCoordinates = coordinates.x + " " + coordinates.y + " " + coordinates.z;
+            try {
+                this.parse(new StringReader(allCoordinates));
+                builder.suggest(String.valueOf(coordinates.x));
+                builder.suggest(coordinates.x + " " + coordinates.y);
+                builder.suggest(allCoordinates);
+            } catch (CommandSyntaxException ignored) {
+            }
+        } else {
+            String[] strings = string.split(" ");
+            String allCoordinates;
+            switch (strings.length) {
+                case 1:
+                    allCoordinates = strings[0] + " " + coordinates.y + " " + coordinates.z;
+                    try {
+                        this.parse(new StringReader(allCoordinates));
+                        builder.suggest(strings[0] + " " + coordinates.y);
+                        builder.suggest(allCoordinates);
+                    } catch (CommandSyntaxException ignored) {
+                    }
+                    break;
+                case 2:
+                    allCoordinates = strings[0] + " " + strings[1] + " " + coordinates.z;
+                    try {
+                        this.parse(new StringReader(allCoordinates));
+                        builder.suggest(allCoordinates);
+                    } catch (CommandSyntaxException ignored) {
+                    }
+                    break;
+            }
+        }
+        return builder.buildFuture();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/WeatherArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/WeatherArgumentType.java
new file mode 100644
index 000000000..46aaa0d04
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/WeatherArgumentType.java
@@ -0,0 +1,54 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.world.weather.Weather;
+import net.minecraft.core.world.weather.Weathers;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.Optional;
+import java.util.concurrent.CompletableFuture;
+
+public class WeatherArgumentType implements ArgumentType<Weather> {
+    private static final Collection<String> EXAMPLES = Arrays.asList(Weathers.OVERWORLD_CLEAR.languageKey, Weathers.OVERWORLD_FOG.languageKey);
+
+    public static WeatherArgumentType weather() {
+        return new WeatherArgumentType();
+    }
+
+    @Override
+    public Weather parse(StringReader reader) throws CommandSyntaxException {
+        final String string = reader.readString();
+
+        for (Weather weather : Weathers.WEATHERS) {
+            if (weather == null) continue;
+            if (CommandHelper.matchesKeyString(weather.languageKey, string)) {
+                return weather;
+            }
+        }
+        throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.weather.invalid_weather"));
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        String remaining = builder.getRemainingLowerCase();
+        for (Weather weather : Weathers.WEATHERS) {
+            if (weather == null) continue;
+            Optional<String> optional = CommandHelper.getStringToSuggest(weather.languageKey, remaining);
+            optional.ifPresent(builder::suggest);
+        }
+        return builder.buildFuture();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/WorldFeatureArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/WorldFeatureArgumentType.java
new file mode 100644
index 000000000..d57950592
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/WorldFeatureArgumentType.java
@@ -0,0 +1,47 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.net.command.helpers.WorldFeatureParser;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.concurrent.CompletableFuture;
+
+public class WorldFeatureArgumentType implements ArgumentType<WorldFeature> {
+    private static final Collection<String> EXAMPLES = Arrays.asList("Dungeon[2, 2, 2]", "Cactus");
+
+    public static ArgumentType<WorldFeature> worldFeature() {
+        return new WorldFeatureArgumentType();
+    }
+
+    @Override
+    public WorldFeature parse(StringReader reader) throws CommandSyntaxException {
+        WorldFeatureParser parser = new WorldFeatureParser(reader);
+        return parser.parse();
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(final CommandContext<S> context, final SuggestionsBuilder builder) {
+        StringReader stringReader = new StringReader(builder.getInput());
+        stringReader.setCursor(builder.getStart());
+        WorldFeatureParser worldFeatureParser = new WorldFeatureParser(stringReader);
+        try {
+            worldFeatureParser.parse();
+        } catch (CommandSyntaxException ignored) {
+        }
+        return worldFeatureParser.fillSuggestions(builder, suggestionsBuilder ->
+            CommandHelper.suggest(CommandHelper.WORLD_FEATURES.keySet(), suggestionsBuilder));
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/AchievementCommand.java b/src/main/java/net/minecraft/core/net/command/commands/AchievementCommand.java
new file mode 100644
index 000000000..cabed5bcb
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/AchievementCommand.java
@@ -0,0 +1,95 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import net.minecraft.core.achievement.Achievement;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.AchievementArgumentType;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class AchievementCommand {
+    private static final SimpleCommandExceptionType PLAYER_ALREADY_HAS_ACHIEVEMENT = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.achievement.grant.exception_already_has_achievement"));
+
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(((LiteralArgumentBuilder.<CommandSource>literal("achievement"))
+            .requires(CommandSource::hasAdmin)
+            .then((LiteralArgumentBuilder.<CommandSource>literal("grant"))
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("entities", EntityArgumentType.players())
+                    .then(RequiredArgumentBuilder.<CommandSource, Achievement>argument("achievement", AchievementArgumentType.achievement())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            List<? extends Entity> entities = c.getArgument("entities", EntitySelector.class).get(source);
+                            Achievement achievement = c.getArgument("achievement", Achievement.class);
+
+                            if (entities.size() == 1 && ((Player) entities.get(0)).getStat(achievement) != 0) {
+                                throw PLAYER_ALREADY_HAS_ACHIEVEMENT.create();
+                            }
+
+                            List<Achievement> achievements = new ArrayList<>();
+                            achievements.add(achievement);
+
+                            while (achievements.get(achievements.size() - 1).parent != null) {
+                                achievements.add(achievements.get(achievements.size() - 1).parent);
+                            }
+                            for (int i = 0; i < achievements.size(); i++) {
+                                for (Entity entity : entities) {
+                                    ((Player) entity).triggerAchievement(achievements.get(achievements.size() - 1 - i));
+                                }
+                            }
+
+                            sendContextualMessage(source, entities, achievement);
+
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("*")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            List<? extends Entity> entities = c.getArgument("entities", EntitySelector.class).get(source);
+
+                            for (Achievement achievement : Achievements.achievementList) {
+                                List<Achievement> achievements = new ArrayList<>();
+                                achievements.add(achievement);
+                                while (achievements.get(achievements.size() - 1).parent != null) {
+                                    achievements.add(achievements.get(achievements.size() - 1).parent);
+                                }
+                                for (int i = 0; i < achievements.size(); i++) {
+                                    for (Entity entity : entities) {
+                                        ((Player) entity).triggerAchievement(achievements.get(achievements.size() - 1 - i));
+                                    }
+                                }
+                            }
+
+                            sendWildcardContextualMessage(source, entities);
+
+                            return Command.SINGLE_SUCCESS;
+                        }))))));
+    }
+
+    private static void sendContextualMessage(CommandSource source, List<? extends Entity> entities, Achievement achievement) {
+        if (entities.size() == 1) {
+            source.sendTranslatableMessage("command.commands.achievement.grant.success_single_entity", achievement.getStatName().trim(), ((Mob) entities.get(0)).getDisplayName());
+        } else {
+            source.sendTranslatableMessage("command.commands.achievement.grant.success_multiple_entities", achievement.getStatName(), entities.size());
+        }
+    }
+
+    private static void sendWildcardContextualMessage(CommandSource source, List<? extends Entity> entities) {
+        if (entities.size() == 1) {
+            source.sendTranslatableMessage("command.commands.achievement.grant.all.success_single_entity", ((Mob) entities.get(0)).getDisplayName());
+        } else {
+            source.sendTranslatableMessage("command.commands.achievement.grant.all.success_multiple_entities", entities.size());
+        }
+    }
+}
